#!/usr/local/bin/perl
$| = 1;
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sumupdate.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================
chop($P = `basename $0`); 

$debug = 1;

print "Start1\n" if $debug;

push(@INC,"/opt/dbamon/lib"); 
require "subs.pl";
require "subsDB.pl";

&msg("Start1b") if $debug;

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
##$os = $ENV{"ORACLE_SID"};

&msg("Start1c") if $debug;

$verb = $ARGV[0];
$mode = lc $ARGV[1];
$arg1 = $ARGV[2];
$arg2 = $ARGV[3];
$arg3 = $ARGV[4];
$arg4 = $ARGV[5];
$arg5 = $ARGV[6];
$arg6 = $ARGV[7];
$arg7 = $ARGV[8];
##$arg8 = $ARGV[9];

&msg("Start2") if $debug;

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

##------------------------------------------------------------------------------
#sub connectDB
##------------------------------------------------------------------------------
#{
#  &msg("Connecting to DB");
#  use DBI;
#  $user = "dbamon";
#  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
#  $data_source = "DBI:Oracle";
#  $database = $os;
#
#  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
#    &error('Failed_on_DB_connect');
#}


#-----------------------------------------------------------------------------
sub insertDetail
#-----------------------------------------------------------------------------
{
  if ($arg4 eq "") {$arg4 = 0;}
  $statement  = "
    insert into dbamon.summary_detail
      (dbamonmode,system,dbms,title,spacealloc,htmlstring) 
    values 
    (\'$mode\',\'$arg1\', \'$arg2\', \'$arg3\', \'$arg4\', \'$arg5\')
  ";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted");
}

#-----------------------------------------------------------------------------
sub deleteDetail
#-----------------------------------------------------------------------------
{
  $statement  = "delete from dbamon.summary_detail where dbamonmode like '$mode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All summary_detail rows deleted");

  $statement  = "delete from dbamon.event_detail where dbamonmode like '$mode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All event_detail rows deleted");
}

#-----------------------------------------------------------------------------
sub insertTot
#-----------------------------------------------------------------------------
{
  $statement  = "
    insert into dbamon.summary_tot
      (dbamonmode,text,count,color) 
    values 
    (\'$mode\',\'$arg1\', \'$arg2\', \'$arg3\')
  ";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted");
}

#-----------------------------------------------------------------------------
sub deleteTot
#-----------------------------------------------------------------------------
{
  $statement  = "delete from dbamon.summary_tot where dbamonmode like '$mode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted");
}

#-----------------------------------------------------------------------------
sub insertDBMS
#-----------------------------------------------------------------------------
{
  if ($arg5 && $arg6)
  {
    $statement  = "
      insert into dbamon.summary_dbms
	(dbamonmode,
	 dbms,
	 count,
	 v_low,
	 v_high,
	 db_count,
	 gb_alloc) 
      values 
      (\'$mode\',
       \'$arg1\', 
       \'$arg2\', 
       \'$arg3\', 
       \'$arg4\',
       \'$arg5\',
       \'$arg6\')
    ";
  }
  else
  {
  $statement  = "
    insert into dbamon.summary_dbms
      (dbamonmode,
       dbms,
       count,
       v_low,
       v_high,
       db_count,
       gb_alloc) 
    values 
    (\'$mode\',
     \'$arg1\', 
     \'$arg2\', 
     \'$arg3\', 
     \'$arg4\',
     null, 
     null)
    ";
  }
  print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted");
}

#-----------------------------------------------------------------------------
sub insertTask
#-----------------------------------------------------------------------------
{
  $statement  = "
    insert into dbamon.task
      (dbamonmode,pid,starttime_num,starttime_char,alpha,iter_num,iter_dur,num_instances) 
    values 
    (\'$mode\',\'$arg1\', \'$arg2\', \'$arg3\', \'$arg4\', \'$arg5\',\'$arg6\',\'$arg7\')
  ";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted");
}

#-----------------------------------------------------------------------------
sub deleteDBMS
#-----------------------------------------------------------------------------
{
  &msg("Deleting from summary_dbms");
  $statement  = "delete from dbamon.summary_dbms where dbamonmode like '$mode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted");
}

#-----------------------------------------------------------------------------
sub deleteTask
#-----------------------------------------------------------------------------
{
  &msg("Deleting from task");
  $statement  = "delete from dbamon.task where dbamonmode like '$mode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted");
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Start3") if $debug;

&msg("Starting verb=$verb mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 P=$P");

&msg("Connecting to DB") if $debug;
&connectDB;
&msg("Back from DB connectDB") if $debug;

if ($verb eq "D") 
{ 
  &deleteDetail; 
  &deleteTot; 
  &deleteDBMS; 
}

if ($verb eq "DS") 
{ 
  &deleteDetail; 
  &deleteTot; 
  &deleteDBMS; 
  &deleteTask; 
}

if ($verb eq "I") 
{ 
  &insertDetail; 
}

if ($verb eq "T") 
{ 
  &insertTot; 
}

if ($verb eq "S") 
{ 
  &insertDBMS; 
}

if ($verb eq "Task") 
{ 
  &insertTask; 
}

&msg("Done");

exit 0;

