# -----------------------------------------------------------------------------
sub oraArclog
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  #
  # Check Oracle to see if arclogs are configured ok and dir not full
  #

  if ($t_arclog_w[$thishost] eq "N")
  {
    &logit("(Not Selected (T_Arclog_Full: is N)",$thishost);
    return 1;
  }

  if ($asmflag[$thishost])
  {
    &logit("(This check not applicable to +ASM instance)",$thishost);
    return 1;
  }

  ##print "#2 t_arclog_w[$thishost]=$t_arclog_w[$thishost]\n";

  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if (! $arclog_by_dest[$i_hosts])
  {
    if ($t_arclog_w[$thishost] eq "") { $t_arclog_w[$thishost] = "80" }
    if ($t_arclog_c[$thishost] eq "") { $t_arclog_c[$thishost] = "90" }
  }
  
  &remsh("$probe[$thishost] arclogs $t_arclog_w[$thishost] $t_arclog_c[$thishost] \"$t_arclog_cmd[$thishost]\"",$tmpfl3,$thishost);
  system("cp $tmpfl3 /tmp/dbamon_oraarclog_probeout_$titleraw[$thishost].txt");

  #See if auto-inhibit occured
  if ($up[$thishost] eq "I")
  {
    logit("(Auto-Inhibited)",$thishost);
    return;
  }

  $arcdir = "";
  $arcdirraw = "";
  $arcfs = "";
  $arcdirfull = "";
  $arcdesterror = "";
  $arcdestwarning = "";
  $arc_t_warn = "";
  $arc_t_crit = "";
  $arc_t_cmd = "";
  $arclogmode = 0;
  $arcdestheader = 0;

  #---- Default
  $arclog[$thishost] = "NoArcLog";

  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<h3>Oracle Archive Log Status</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");

  open(TMPFL3, "$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    $z = substr($F0,0,3);
    if ($z eq "<tr")
    {
      if ($arcdestheader != 1)
      {
	logDetails($thishost,"</table>");
	logDetails($thishost,"<h3>Oracle Archive Log Destination Data (8i and Higher Only)</h3>");
	logDetails($thishost,"<table border=1>");
        $arcdestheader = 1;
      }
      &logDetails($thishost,$F0);
    }
    if ($F2 eq "arcflag:")    {  $arclogflag[$thishost] = $F3; }
    if ($F2 eq "arcdir:")     {  $arcdir = $F3; }
    if ($F2 eq "arcfs:")      {  $arcfs = $F3; }
    if ($F2 eq "arcdirfull:") {  $arcdirfull = $F3; }
    if ($F2 eq "arcdirraw:")  {  $arcdirraw = $F3; }
    if ($F2 eq "arc_t_warn:") {  $arc_t_warn = $F3; }
    if ($F2 eq "arc_t_crit:") {  $arc_t_crit = $F3; }
    if ($F2 eq "arc_t_cmd:")  {  $arc_t_cmd = $F3; }
    if ($F2 eq "ARCDESTINOH:") 
    {
      &event("C",$thishost,"Archivelog destination(s) ($F3) are in ORACLE_HOME filesystem","ArcInOH","DBA662",$tmpfl3);
    }
    if ($F2 eq "arccheckbadformat:") 
    {
      &event("W",$thishost,"Archivelog $F3 has invalid format - Should be arch%t_%s.dbf","ArcFmtErr","DBA650",$tmpfl3);
    }
    if ($F2 eq "arcdesterror:") 
    {
      $arcdesterror = $F3;
      $arcdestlist = $F4;
    }
    if ($F2 eq "arcdestwarning:") 
    {
      $arcdestwarning = $F3;
      $arcdestlist_w = $F4;
    }
    if ($F2 eq "arclogmode:" && $F3 eq "Archive")
    {
      $arclog[$thishost] = "ArcLog";
      $arclogmode = 1;
    }
    # arccmdrun is the last display for each destination
    if ($F2 eq "arccmdrun:") 
    {  
      $arccmdrun = $F3;

      if ($arccmdrun eq "Y")
      {
	$rerun = "(Backup Was Invoked)";
	##system("echo '' | dbamon_mailer -s 'DBAmon oraArclog() ARC Backup Invoked - $titleraw[$thishost] $arcdirfull $arcdir' $debug_email");
      }
      else
      {
	$rerun = "";
      }

      if ($arclogflag[$thishost] eq "E")
      {
	&event("W",$thishost,"Oracle Archive Log Dir is NULL: Something went wrong with svrmgrl","ArcLgErr","DBA645W",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "W")
      {
	&event("W",$thishost,"Oracle Archive Log Dir: $arcdir FS $arcfs is ${arcdirfull}% Full - Warning (Threshold: ${arc_t_warn}%) $rerun","ArcLgFUll","DBA641W",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "C")
      {
        system("ll $tmpfl3");
	&event("C",$thishost,"Archive Log Dir Is ${arcdirfull}% Full - arcdir=$arcdir arcfs=$arcfs - Critical (Threshold: ${arc_t_crit}%) $rerun","ArcLgFull","DBA642",$tmpfl3);
        system("ll $tmpfl3");
      }
      if ($arclogflag[$thishost] eq "N")
      {
	&event("C",$thishost,"Oracle Archive Logging is ON; But Auto Archiving is OFF","ArcLgOff","DBA643C",$tmpfl3);
      }
      if ($arcdesterror eq "Y")
      {
	&event("W",$thishost,"Oracle Archive Log Destination: $arcdestlist in ERROR Status - Auto restart of destination was not successful","ArcLgDest","DBA646",$tmpfl3);
      }
      if ($arcdestwarning eq "Y")
      {
	&event("W",$thishost,"Oracle Archive Log Destination: $arcdestlist_w was automatically restarted","ArcLgDestFixed","DBA647C",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "")
      {
	$msg = sprintf("OK - Arclog Dir %s FS $arcfs is %s%% Full - Thresholds: $t_arclog_w[$thishost]/$t_arclog_c[$thishost]",$arcdir,$arcdirfull);
	&logit($msg,$thishost);
      }
      &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Log Mode:</b><td>$f_s $arclog[$thishost]");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Dest:</b><td>$f_s $arcdirraw<td>$f_s (From init.ora)");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Directory:</b><td>$f_s $arcdir<td>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Filesystem:</b><td>$f_s $arcfs<td>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Filesystem Full Warning Threshold:</b><td>$f_s $arc_t_warn<td>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Filesystem Full Critical Threshold:</b><td>$f_s $arc_t_crit<td>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Directory Percent Full:</b><td>$f_s $arcdirfull<td>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Backup Command:</b><td>$f_s $arc_t_cmd<td>");
      &logDetails($thishost,"<tr><td>$f_s <b>Archive Backup Invoked?:</b><td>$f_s $arccmdrun<td>");
    }
  }
  close(TMPFL3);

  if ($arclogmode)
  {
  }
  #elsif ($up_arclogmode eq "ARCHIVELOG")
  #{
  #  $arclog[$thishost] = "ArcLog";
  #}
  else
  {
    $arclog[$thishost] = "NoArcLog";
    &logit("Archive Log Mode is OFF",$thishost);
  }

  &logDetails($thishost,"</table><hr>");
}
# -----------------------------------------------------------------------------
1;
